# coding: utf-8

"""
    Elastic Email REST API

    This API is based on the REST API architecture, allowing the user to easily manage their data with this resource-based approach.    Every API call is established on which specific request type (GET, POST, PUT, DELETE) will be used.    The API has a limit of 20 concurrent connections and a hard timeout of 600 seconds per request.    To start using this API, you will need your Access Token (available <a target=\"_blank\" href=\"https://app.elasticemail.com/marketing/settings/new/manage-api\">here</a>). Remember to keep it safe. Required access levels are listed in the given request’s description.    Downloadable library clients can be found in our Github repository <a target=\"_blank\" href=\"https://github.com/ElasticEmail?tab=repositories&q=%22rest+api%22+in%3Areadme\">here</a>  # noqa: E501

    The version of the OpenAPI document: 4.0.0
    Contact: support@elasticemail.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from ElasticEmail import schemas  # noqa: F401


class Contact(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Contact
    """


    class MetaOapg:
        
        class properties:
            Email = schemas.StrSchema
        
            @staticmethod
            def Status() -> typing.Type['ContactStatus']:
                return ContactStatus
            FirstName = schemas.StrSchema
            LastName = schemas.StrSchema
            
            
            class CustomFields(
                schemas.DictSchema
            ):
            
            
                class MetaOapg:
                    additional_properties = schemas.StrSchema
                
                def __getitem__(self, name: typing.Union[str, ]) -> MetaOapg.additional_properties:
                    # dict_instance[name] accessor
                    return super().__getitem__(name)
                
                def get_item_oapg(self, name: typing.Union[str, ]) -> MetaOapg.additional_properties:
                    return super().get_item_oapg(name)
            
                def __new__(
                    cls,
                    *_args: typing.Union[dict, frozendict.frozendict, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                    **kwargs: typing.Union[MetaOapg.additional_properties, str, ],
                ) -> 'CustomFields':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                        **kwargs,
                    )
        
            @staticmethod
            def Consent() -> typing.Type['ConsentData']:
                return ConsentData
        
            @staticmethod
            def Source() -> typing.Type['ContactSource']:
                return ContactSource
            DateAdded = schemas.DateTimeSchema
            
            
            class DateUpdated(
                schemas.DateTimeBase,
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    format = 'date-time'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, datetime, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'DateUpdated':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
            
            
            class StatusChangeDate(
                schemas.DateTimeBase,
                schemas.StrBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneStrMixin
            ):
            
            
                class MetaOapg:
                    format = 'date-time'
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[None, str, datetime, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'StatusChangeDate':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                    )
        
            @staticmethod
            def Activity() -> typing.Type['ContactActivity']:
                return ContactActivity
            __annotations__ = {
                "Email": Email,
                "Status": Status,
                "FirstName": FirstName,
                "LastName": LastName,
                "CustomFields": CustomFields,
                "Consent": Consent,
                "Source": Source,
                "DateAdded": DateAdded,
                "DateUpdated": DateUpdated,
                "StatusChangeDate": StatusChangeDate,
                "Activity": Activity,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Email"]) -> MetaOapg.properties.Email: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Status"]) -> 'ContactStatus': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["FirstName"]) -> MetaOapg.properties.FirstName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["LastName"]) -> MetaOapg.properties.LastName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["CustomFields"]) -> MetaOapg.properties.CustomFields: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Consent"]) -> 'ConsentData': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Source"]) -> 'ContactSource': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["DateAdded"]) -> MetaOapg.properties.DateAdded: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["DateUpdated"]) -> MetaOapg.properties.DateUpdated: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["StatusChangeDate"]) -> MetaOapg.properties.StatusChangeDate: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Activity"]) -> 'ContactActivity': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["Email", "Status", "FirstName", "LastName", "CustomFields", "Consent", "Source", "DateAdded", "DateUpdated", "StatusChangeDate", "Activity", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Email"]) -> typing.Union[MetaOapg.properties.Email, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Status"]) -> typing.Union['ContactStatus', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["FirstName"]) -> typing.Union[MetaOapg.properties.FirstName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["LastName"]) -> typing.Union[MetaOapg.properties.LastName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["CustomFields"]) -> typing.Union[MetaOapg.properties.CustomFields, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Consent"]) -> typing.Union['ConsentData', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Source"]) -> typing.Union['ContactSource', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["DateAdded"]) -> typing.Union[MetaOapg.properties.DateAdded, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["DateUpdated"]) -> typing.Union[MetaOapg.properties.DateUpdated, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["StatusChangeDate"]) -> typing.Union[MetaOapg.properties.StatusChangeDate, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Activity"]) -> typing.Union['ContactActivity', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["Email", "Status", "FirstName", "LastName", "CustomFields", "Consent", "Source", "DateAdded", "DateUpdated", "StatusChangeDate", "Activity", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        Email: typing.Union[MetaOapg.properties.Email, str, schemas.Unset] = schemas.unset,
        Status: typing.Union['ContactStatus', schemas.Unset] = schemas.unset,
        FirstName: typing.Union[MetaOapg.properties.FirstName, str, schemas.Unset] = schemas.unset,
        LastName: typing.Union[MetaOapg.properties.LastName, str, schemas.Unset] = schemas.unset,
        CustomFields: typing.Union[MetaOapg.properties.CustomFields, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        Consent: typing.Union['ConsentData', schemas.Unset] = schemas.unset,
        Source: typing.Union['ContactSource', schemas.Unset] = schemas.unset,
        DateAdded: typing.Union[MetaOapg.properties.DateAdded, str, datetime, schemas.Unset] = schemas.unset,
        DateUpdated: typing.Union[MetaOapg.properties.DateUpdated, None, str, datetime, schemas.Unset] = schemas.unset,
        StatusChangeDate: typing.Union[MetaOapg.properties.StatusChangeDate, None, str, datetime, schemas.Unset] = schemas.unset,
        Activity: typing.Union['ContactActivity', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'Contact':
        return super().__new__(
            cls,
            *_args,
            Email=Email,
            Status=Status,
            FirstName=FirstName,
            LastName=LastName,
            CustomFields=CustomFields,
            Consent=Consent,
            Source=Source,
            DateAdded=DateAdded,
            DateUpdated=DateUpdated,
            StatusChangeDate=StatusChangeDate,
            Activity=Activity,
            _configuration=_configuration,
            **kwargs,
        )

from ElasticEmail.model.consent_data import ConsentData
from ElasticEmail.model.contact_activity import ContactActivity
from ElasticEmail.model.contact_source import ContactSource
from ElasticEmail.model.contact_status import ContactStatus
