# coding: utf-8

"""
    Elastic Email REST API

    This API is based on the REST API architecture, allowing the user to easily manage their data with this resource-based approach.    Every API call is established on which specific request type (GET, POST, PUT, DELETE) will be used.    The API has a limit of 20 concurrent connections and a hard timeout of 600 seconds per request.    To start using this API, you will need your Access Token (available <a target=\"_blank\" href=\"https://app.elasticemail.com/marketing/settings/new/manage-api\">here</a>). Remember to keep it safe. Required access levels are listed in the given request’s description.    Downloadable library clients can be found in our Github repository <a target=\"_blank\" href=\"https://github.com/ElasticEmail?tab=repositories&q=%22rest+api%22+in%3Areadme\">here</a>  # noqa: E501

    The version of the OpenAPI document: 4.0.0
    Contact: support@elasticemail.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from ElasticEmail import schemas  # noqa: F401


class SubAccountInfo(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Detailed information about SubAccount.
    """


    class MetaOapg:
        
        class properties:
            PublicAccountID = schemas.StrSchema
            Email = schemas.StrSchema
        
            @staticmethod
            def Settings() -> typing.Type['SubaccountSettingsInfo']:
                return SubaccountSettingsInfo
            LastActivity = schemas.DateTimeSchema
            EmailCredits = schemas.Int32Schema
            TotalEmailsSent = schemas.Int64Schema
            Reputation = schemas.Float64Schema
        
            @staticmethod
            def Status() -> typing.Type['AccountStatusEnum']:
                return AccountStatusEnum
            ContactsCount = schemas.Int32Schema
            __annotations__ = {
                "PublicAccountID": PublicAccountID,
                "Email": Email,
                "Settings": Settings,
                "LastActivity": LastActivity,
                "EmailCredits": EmailCredits,
                "TotalEmailsSent": TotalEmailsSent,
                "Reputation": Reputation,
                "Status": Status,
                "ContactsCount": ContactsCount,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["PublicAccountID"]) -> MetaOapg.properties.PublicAccountID: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Email"]) -> MetaOapg.properties.Email: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Settings"]) -> 'SubaccountSettingsInfo': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["LastActivity"]) -> MetaOapg.properties.LastActivity: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["EmailCredits"]) -> MetaOapg.properties.EmailCredits: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["TotalEmailsSent"]) -> MetaOapg.properties.TotalEmailsSent: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Reputation"]) -> MetaOapg.properties.Reputation: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Status"]) -> 'AccountStatusEnum': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["ContactsCount"]) -> MetaOapg.properties.ContactsCount: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["PublicAccountID", "Email", "Settings", "LastActivity", "EmailCredits", "TotalEmailsSent", "Reputation", "Status", "ContactsCount", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["PublicAccountID"]) -> typing.Union[MetaOapg.properties.PublicAccountID, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Email"]) -> typing.Union[MetaOapg.properties.Email, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Settings"]) -> typing.Union['SubaccountSettingsInfo', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["LastActivity"]) -> typing.Union[MetaOapg.properties.LastActivity, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["EmailCredits"]) -> typing.Union[MetaOapg.properties.EmailCredits, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["TotalEmailsSent"]) -> typing.Union[MetaOapg.properties.TotalEmailsSent, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Reputation"]) -> typing.Union[MetaOapg.properties.Reputation, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Status"]) -> typing.Union['AccountStatusEnum', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["ContactsCount"]) -> typing.Union[MetaOapg.properties.ContactsCount, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["PublicAccountID", "Email", "Settings", "LastActivity", "EmailCredits", "TotalEmailsSent", "Reputation", "Status", "ContactsCount", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        PublicAccountID: typing.Union[MetaOapg.properties.PublicAccountID, str, schemas.Unset] = schemas.unset,
        Email: typing.Union[MetaOapg.properties.Email, str, schemas.Unset] = schemas.unset,
        Settings: typing.Union['SubaccountSettingsInfo', schemas.Unset] = schemas.unset,
        LastActivity: typing.Union[MetaOapg.properties.LastActivity, str, datetime, schemas.Unset] = schemas.unset,
        EmailCredits: typing.Union[MetaOapg.properties.EmailCredits, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        TotalEmailsSent: typing.Union[MetaOapg.properties.TotalEmailsSent, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        Reputation: typing.Union[MetaOapg.properties.Reputation, decimal.Decimal, int, float, schemas.Unset] = schemas.unset,
        Status: typing.Union['AccountStatusEnum', schemas.Unset] = schemas.unset,
        ContactsCount: typing.Union[MetaOapg.properties.ContactsCount, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'SubAccountInfo':
        return super().__new__(
            cls,
            *_args,
            PublicAccountID=PublicAccountID,
            Email=Email,
            Settings=Settings,
            LastActivity=LastActivity,
            EmailCredits=EmailCredits,
            TotalEmailsSent=TotalEmailsSent,
            Reputation=Reputation,
            Status=Status,
            ContactsCount=ContactsCount,
            _configuration=_configuration,
            **kwargs,
        )

from ElasticEmail.model.account_status_enum import AccountStatusEnum
from ElasticEmail.model.subaccount_settings_info import SubaccountSettingsInfo
