# coding: utf-8

"""
    Elastic Email REST API

    This API is based on the REST API architecture, allowing the user to easily manage their data with this resource-based approach.    Every API call is established on which specific request type (GET, POST, PUT, DELETE) will be used.    The API has a limit of 20 concurrent connections and a hard timeout of 600 seconds per request.    To start using this API, you will need your Access Token (available <a target=\"_blank\" href=\"https://app.elasticemail.com/marketing/settings/new/manage-api\">here</a>). Remember to keep it safe. Required access levels are listed in the given request’s description.    Downloadable library clients can be found in our Github repository <a target=\"_blank\" href=\"https://github.com/ElasticEmail?tab=repositories&q=%22rest+api%22+in%3Areadme\">here</a>  # noqa: E501

    The version of the OpenAPI document: 4.0.0
    Contact: support@elasticemail.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from ElasticEmail import schemas  # noqa: F401


class Template(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Template info
    """


    class MetaOapg:
        
        class properties:
        
            @staticmethod
            def TemplateType() -> typing.Type['TemplateType']:
                return TemplateType
            Name = schemas.StrSchema
            DateAdded = schemas.DateTimeSchema
            Subject = schemas.StrSchema
            
            
            class Body(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['BodyPart']:
                        return BodyPart
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['BodyPart'], typing.List['BodyPart']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'Body':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'BodyPart':
                    return super().__getitem__(i)
        
            @staticmethod
            def TemplateScope() -> typing.Type['TemplateScope']:
                return TemplateScope
            __annotations__ = {
                "TemplateType": TemplateType,
                "Name": Name,
                "DateAdded": DateAdded,
                "Subject": Subject,
                "Body": Body,
                "TemplateScope": TemplateScope,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["TemplateType"]) -> 'TemplateType': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Name"]) -> MetaOapg.properties.Name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["DateAdded"]) -> MetaOapg.properties.DateAdded: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Subject"]) -> MetaOapg.properties.Subject: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["Body"]) -> MetaOapg.properties.Body: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["TemplateScope"]) -> 'TemplateScope': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["TemplateType", "Name", "DateAdded", "Subject", "Body", "TemplateScope", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["TemplateType"]) -> typing.Union['TemplateType', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Name"]) -> typing.Union[MetaOapg.properties.Name, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["DateAdded"]) -> typing.Union[MetaOapg.properties.DateAdded, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Subject"]) -> typing.Union[MetaOapg.properties.Subject, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["Body"]) -> typing.Union[MetaOapg.properties.Body, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["TemplateScope"]) -> typing.Union['TemplateScope', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["TemplateType", "Name", "DateAdded", "Subject", "Body", "TemplateScope", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        TemplateType: typing.Union['TemplateType', schemas.Unset] = schemas.unset,
        Name: typing.Union[MetaOapg.properties.Name, str, schemas.Unset] = schemas.unset,
        DateAdded: typing.Union[MetaOapg.properties.DateAdded, str, datetime, schemas.Unset] = schemas.unset,
        Subject: typing.Union[MetaOapg.properties.Subject, str, schemas.Unset] = schemas.unset,
        Body: typing.Union[MetaOapg.properties.Body, list, tuple, schemas.Unset] = schemas.unset,
        TemplateScope: typing.Union['TemplateScope', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'Template':
        return super().__new__(
            cls,
            *_args,
            TemplateType=TemplateType,
            Name=Name,
            DateAdded=DateAdded,
            Subject=Subject,
            Body=Body,
            TemplateScope=TemplateScope,
            _configuration=_configuration,
            **kwargs,
        )

from ElasticEmail.model.body_part import BodyPart
from ElasticEmail.model.template_scope import TemplateScope
from ElasticEmail.model.template_type import TemplateType
